diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
index 6732801a6..61f3dbabf 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
@@ -3,8 +3,6 @@ package net.minecraft.client.gui.hud.component;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
-import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
-import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.Global;
 import net.minecraft.core.item.ItemStack;
@@ -20,12 +18,17 @@ import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 
+import java.util.ArrayList;
+import java.util.List;
+
 import static net.minecraft.core.util.helper.Utils.floor10;
 
-public class HudComponentInfoOverlay
-    extends HudComponentMovable {
+public class HudComponentInfoOverlay extends HudComponentMovable {
+
+    private record RenderLine(String text, int color) {}
+
     public HudComponentInfoOverlay(String key, Layout layout) {
-        super(key, 130, 112, layout);
+        super(key, 175, 150, layout);
     }
 
     @Override
@@ -33,13 +36,19 @@ public class HudComponentInfoOverlay
         return GameSettings.IMMERSIVE_MODE.drawOverlays() && !GameSettings.SHOW_DEBUG_SCREEN.value;
     }
 
-    private void drawString(String string, int x, int y, int argb, boolean rightAligned) {
-        int xOffset = -2;
-        if (rightAligned) {
-            xOffset = mc.font.stringWidth(string) + 2 - this.getXSize();
-        }
+    private void drawAlignedString(String text, int boxX, int boxY, int boxWidth, int argb) {
+        int textWidth = mc.font.stringWidth(text);
+        float xMult = GameSettings.HORIZONTAL_INFO_TEXT_ALIGNMENT.value.multiplier;
+        int padding = 2;
+        int renderX = boxX + padding + (int) ((boxWidth - (padding * 2) - textWidth) * xMult);
+        mc.font.render(text, renderX, boxY).setShadow().setColor(argb).call();
+    }
 
-        mc.font.render(string, x - xOffset, y).setShadow().setColor(argb).call();
+    private int getPreviewColor(int baseColor, boolean isEnabled) {
+        if (isEnabled) {
+            return baseColor;
+        }
+        return (baseColor & 0x00FFFFFF) | 0x55000000;
     }
 
     @Override
@@ -47,19 +56,6 @@ public class HudComponentInfoOverlay
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
-        boolean rightAligned = false;
-        if (this.getLayout() instanceof LayoutAbsolute layout) {
-            final ComponentAnchor anchor = layout.getAnchor();
-            if (anchor == ComponentAnchor.TOP_RIGHT || anchor == ComponentAnchor.CENTER_RIGHT || anchor == ComponentAnchor.BOTTOM_RIGHT) {
-                rightAligned = true;
-            }
-        } else if (this.getLayout() instanceof LayoutSnap layout) {
-            final ComponentAnchor anchor = layout.getAnchor();
-            if (anchor == ComponentAnchor.TOP_RIGHT || anchor == ComponentAnchor.CENTER_RIGHT || anchor == ComponentAnchor.BOTTOM_RIGHT) {
-                rightAligned = true;
-            }
-        }
-
         boolean clock = false;
         boolean compass = false;
         boolean rotaryCalendar = false;
@@ -72,84 +68,78 @@ public class HudComponentInfoOverlay
             for (int iinv = 0; iinv < mc.thePlayer.inventory.getContainerSize(); iinv++) {
                 ItemStack item = mc.thePlayer.inventory.getItem(iinv);
                 if (item != null) {
-                    if (item.itemID == Items.TOOL_CLOCK.id) {
-                        clock = true;
-                    }
-                    if (item.itemID == Items.TOOL_COMPASS.id) {
-                        compass = true;
-                    }
-                    if (item.itemID == Items.TOOL_CALENDAR.id) {
-                        rotaryCalendar = true;
-                    }
+                    if (item.itemID == Items.TOOL_CLOCK.id) clock = true;
+                    if (item.itemID == Items.TOOL_COMPASS.id) compass = true;
+                    if (item.itemID == Items.TOOL_CALENDAR.id) rotaryCalendar = true;
                 }
             }
         }
 
-        int tsp = 2;
-        int line = 0;
-        int lineHeight = 10;
+        List<RenderLine> lines = new ArrayList<>();
 
         if (GameSettings.VERSION_IN_OVERLAY.value) {
-            int color;
-            if (GameSettings.OVERLAY_MODE.value == 2) {
-                color = 0xFFFFFF60;
-            } else {
-                color = 0xFFFFFFFF;
-            }
-            drawString("Better than Adventure! " + TextFormatting.WHITE + Global.VERSION, x, y + tsp + lineHeight * line++, color, rightAligned);
+            int color = (GameSettings.OVERLAY_MODE.value == 2) ? 0xFFFFFF60 : 0xFFFFFFFF;
+            lines.add(new RenderLine("Better than Adventure! " + TextFormatting.WHITE + Global.VERSION, color));
         }
+
         if (GameSettings.FPS_IN_OVERLAY.value) {
-            drawString(mc.lingDebugFPS, x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+            lines.add(new RenderLine(mc.lingDebugFPS, 0xFFFFFFFF));
         }
+
         if (compass) {
-            if (GameSettings.OVERLAY_SHOW_COORDS.value) {
+            if (GameSettings.COORDS_IN_OVERLAY.value) {
                 if (GameSettings.OVERLAY_MODE.value == 0) {
-                    drawString("x: " + floor10(mc.thePlayer.x) + " y: " + floor10(mc.thePlayer.y) + " z: " + floor10(mc.thePlayer.z), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                    lines.add(new RenderLine("x: " + floor10(mc.thePlayer.x) + " y: " + floor10(mc.thePlayer.y) + " z: " + floor10(mc.thePlayer.z), 0xFFFFFFFF));
                 }
                 if (GameSettings.OVERLAY_MODE.value == 1) {
-                    drawString("x: " + floor10(mc.thePlayer.x), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
-                    drawString("y: " + floor10(mc.thePlayer.y), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
-                    drawString("z: " + floor10(mc.thePlayer.z), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                    lines.add(new RenderLine("x: " + floor10(mc.thePlayer.x), 0xFFFFFFFF));
+                    lines.add(new RenderLine("y: " + floor10(mc.thePlayer.y), 0xFFFFFFFF));
+                    lines.add(new RenderLine("z: " + floor10(mc.thePlayer.z), 0xFFFFFFFF));
                 }
                 if (GameSettings.OVERLAY_MODE.value == 2) {
-                    drawString("x: " + floor10(mc.thePlayer.x), x, y + tsp + lineHeight * line++, 0xFFFF8080, rightAligned);
-                    drawString("y: " + floor10(mc.thePlayer.y), x, y + tsp + lineHeight * line++, 0xFF80FF80, rightAligned);
-                    drawString("z: " + floor10(mc.thePlayer.z), x, y + tsp + lineHeight * line++, 0xFF8080FF, rightAligned);
+                    lines.add(new RenderLine("x: " + floor10(mc.thePlayer.x), 0xFFFF8080));
+                    lines.add(new RenderLine("y: " + floor10(mc.thePlayer.y), 0xFF80FF80));
+                    lines.add(new RenderLine("z: " + floor10(mc.thePlayer.z), 0xFF8080FF));
                 }
             }
-            if (GameSettings.OVERLAY_SHOW_DIRECTION.value) {
-                drawString(I18n.getInstance().translateKey(HudIngame.getFacingDirection(mc.thePlayer).getTranslationKey()), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+            if (GameSettings.DIRECTION_IN_OVERLAY.value) {
+                lines.add(new RenderLine(I18n.getInstance().translateKey(HudIngame.getFacingDirection(mc.thePlayer).getTranslationKey()), 0xFFFFFFFF));
             }
         }
+
         if (clock) {
-            if (GameSettings.OVERLAY_SHOW_TIME.value) {
+            if (GameSettings.TIME_IN_OVERLAY.value) {
+                int color = (GameSettings.OVERLAY_MODE.value == 2) ? 0xFFFFFF80 : 0xFFFFFFFF;
                 if (GameSettings.OVERLAY_MODE.value == 0) {
-                    drawString(String.format("%s %s %d", HudIngame.getTimeString(mc), I18n.getInstance().translateKey("unit.day"), mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
+                    lines.add(new RenderLine(String.format("%s %s %d", HudIngame.getTimeString(mc), I18n.getInstance().translateKey("unit.day"), mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), color));
                 }
                 if (GameSettings.OVERLAY_MODE.value > 0) {
-                    drawString(HudIngame.getTimeString(mc), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
-                    drawString(String.format("%s %d", I18n.getInstance().translateKey("unit.day"), mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
+                    lines.add(new RenderLine(HudIngame.getTimeString(mc), color));
+                    lines.add(new RenderLine(String.format("%s %d", I18n.getInstance().translateKey("unit.day"), mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), color));
                 }
             }
         }
+
         if (rotaryCalendar) {
-            if (GameSettings.OVERLAY_SHOW_SEASON.value) {
+            if (GameSettings.SEASON_IN_OVERLAY.value) {
                 Season season = mc.currentWorld.getSeasonManager().getCurrentSeason();
                 if (season != null) {
-                    drawString(season.getTranslatedName(), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF, rightAligned);
+                    lines.add(new RenderLine(season.getTranslatedName(), GameSettings.OVERLAY_MODE.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF));
                 }
             }
-            if (GameSettings.OVERLAY_SHOW_WEATHER.value) {
+            if (GameSettings.WEATHER_IN_OVERLAY.value) {
                 Weather weather = mc.currentWorld.getCurrentWeather();
                 if (weather != null && weather != mc.currentWorld.getWorldType().getDefaultWeather()) {
-                    drawString(I18n.getInstance().translateKey(weather.getNameLanguageKey()), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF, rightAligned);
+                    lines.add(new RenderLine(I18n.getInstance().translateKey(weather.getNameLanguageKey()), GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF));
                 }
             }
-            if (GameSettings.OVERLAY_SHOW_BIOME.value) {
+            if (GameSettings.BIOME_IN_OVERLAY.value) {
                 String key = mc.currentWorld.getBlockBiome(new TilePos(mc.thePlayer)).translationKey;
-                drawString(I18n.getInstance().translateKey(key), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                lines.add(new RenderLine(I18n.getInstance().translateKey(key), 0xFFFFFFFF));
             }
         }
+
+        drawLines(lines, x, y);
     }
 
     @Override
@@ -157,76 +147,77 @@ public class HudComponentInfoOverlay
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
-        boolean rightAligned = false;
-        if (layout instanceof LayoutAbsolute) {
-            final LayoutAbsolute l = (LayoutAbsolute) this.getLayout();
-            final ComponentAnchor anchor = l.getAnchor();
-            if (anchor == ComponentAnchor.TOP_RIGHT || anchor == ComponentAnchor.CENTER_RIGHT || anchor == ComponentAnchor.BOTTOM_RIGHT) {
-                rightAligned = true;
-            }
-        } else if (layout instanceof LayoutSnap) {
-            final LayoutSnap l = (LayoutSnap) this.getLayout();
-            final ComponentAnchor anchor = l.getAnchor();
-            if (anchor == ComponentAnchor.TOP_RIGHT || anchor == ComponentAnchor.CENTER_RIGHT || anchor == ComponentAnchor.BOTTOM_RIGHT) {
-                rightAligned = true;
-            }
-        }
+        List<RenderLine> lines = new ArrayList<>();
 
-        int tsp = 2;
-        int line = 0;
-        int lineHeight = 10;
+        int versionBaseColor = (GameSettings.OVERLAY_MODE.value == 2) ? 0xFFFFFF60 : 0xFFFFFFFF;
+        boolean versionEnabled = GameSettings.VERSION_IN_OVERLAY.value;
 
-        { // FPS
-            drawString("60 fps", x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
-        }
-        { // Compass
-            {
-                final double px = 372.853;
-                final double py = 64.355;
-                final double pz = 38472.333;
+        String versionText = "Better than Adventure! " + (versionEnabled ? TextFormatting.WHITE : "") + Global.VERSION;
+        lines.add(new RenderLine(versionText, getPreviewColor(versionBaseColor, versionEnabled)));
 
-                if (GameSettings.OVERLAY_MODE.value == 0) {
-                    drawString("x: " + floor10(px) + " y: " + floor10(py) + " z: " + floor10(pz), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
-                }
-                if (GameSettings.OVERLAY_MODE.value == 1) {
-                    drawString("x: " + floor10(px), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
-                    drawString("y: " + floor10(py), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
-                    drawString("z: " + floor10(pz), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
-                }
-                if (GameSettings.OVERLAY_MODE.value == 2) {
-                    drawString("x: " + floor10(px), x, y + tsp + lineHeight * line++, 0xFFFF8080, rightAligned);
-                    drawString("y: " + floor10(py), x, y + tsp + lineHeight * line++, 0xFF80FF80, rightAligned);
-                    drawString("z: " + floor10(pz), x, y + tsp + lineHeight * line++, 0xFF8080FF, rightAligned);
-                }
-            }
-            {
-                drawString(I18n.getInstance().translateKey(Direction.NORTH.getTranslationKey()), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
-            }
+        boolean fpsEnabled = GameSettings.FPS_IN_OVERLAY.value;
+        lines.add(new RenderLine("127 fps", getPreviewColor(0xFFFFFFFF, fpsEnabled)));
+
+        final double px = 372.853;
+        final double py = 64.355;
+        final double pz = 38472.333;
+        boolean coordsEnabled = GameSettings.COORDS_IN_OVERLAY.value;
+
+        if (GameSettings.OVERLAY_MODE.value == 0) {
+            lines.add(new RenderLine("x: " + floor10(px) + " y: " + floor10(py) + " z: " + floor10(pz), getPreviewColor(0xFFFFFFFF, coordsEnabled)));
+        } else if (GameSettings.OVERLAY_MODE.value == 1) {
+            lines.add(new RenderLine("x: " + floor10(px), getPreviewColor(0xFFFFFFFF, coordsEnabled)));
+            lines.add(new RenderLine("y: " + floor10(py), getPreviewColor(0xFFFFFFFF, coordsEnabled)));
+            lines.add(new RenderLine("z: " + floor10(pz), getPreviewColor(0xFFFFFFFF, coordsEnabled)));
+        } else if (GameSettings.OVERLAY_MODE.value == 2) {
+            lines.add(new RenderLine("x: " + floor10(px), getPreviewColor(0xFFFF8080, coordsEnabled)));
+            lines.add(new RenderLine("y: " + floor10(py), getPreviewColor(0xFF80FF80, coordsEnabled)));
+            lines.add(new RenderLine("z: " + floor10(pz), getPreviewColor(0xFF8080FF, coordsEnabled)));
         }
-        {
-            {
-                if (GameSettings.OVERLAY_MODE.value == 0) {
-                    drawString(String.format("%s %s %d", "8:32", I18n.getInstance().translateKey("unit.day"), 500), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
-                }
-                if (GameSettings.OVERLAY_MODE.value > 0) {
-                    drawString("8:32", x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
-                    drawString(String.format("%s %d", I18n.getInstance().translateKey("unit.day"), 500), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
-                }
-            }
+
+        boolean dirEnabled = GameSettings.DIRECTION_IN_OVERLAY.value;
+        lines.add(new RenderLine(I18n.getInstance().translateKey(Direction.NORTH.getTranslationKey()), getPreviewColor(0xFFFFFFFF, dirEnabled)));
+
+        int clockColor = (GameSettings.OVERLAY_MODE.value == 2) ? 0xFFFFFF80 : 0xFFFFFFFF;
+        boolean timeEnabled = GameSettings.TIME_IN_OVERLAY.value;
+
+        if (GameSettings.OVERLAY_MODE.value == 0) {
+            lines.add(new RenderLine(String.format("%s %s %d", "8:32", I18n.getInstance().translateKey("unit.day"), 500), getPreviewColor(clockColor, timeEnabled)));
+        } else if (GameSettings.OVERLAY_MODE.value > 0) {
+            lines.add(new RenderLine("8:32", getPreviewColor(clockColor, timeEnabled)));
+            lines.add(new RenderLine(String.format("%s %d", I18n.getInstance().translateKey("unit.day"), 500), getPreviewColor(clockColor, timeEnabled)));
         }
-        {
-            {
-                Season season = Seasons.OVERWORLD_SUMMER;
-                drawString(season.getTranslatedName(), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF, rightAligned);
-            }
-            {
-                Weather weather = Weathers.OVERWORLD_FOG;
-                drawString(I18n.getInstance().translateKey(weather.getNameLanguageKey()), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF, rightAligned);
-            }
-            {
-                String key = Biomes.OVERWORLD_GRASSLANDS.translationKey;
-                drawString(I18n.getInstance().translateKey(key), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
-            }
+
+        Season season = Seasons.OVERWORLD_SUMMER;
+        boolean seasonEnabled = GameSettings.SEASON_IN_OVERLAY.value;
+        lines.add(new RenderLine(season.getTranslatedName(), getPreviewColor(GameSettings.OVERLAY_MODE.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF, seasonEnabled)));
+
+        Weather weather = Weathers.OVERWORLD_FOG;
+        boolean weatherEnabled = GameSettings.WEATHER_IN_OVERLAY.value;
+        lines.add(new RenderLine(I18n.getInstance().translateKey(weather.getNameLanguageKey()), getPreviewColor(GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF, weatherEnabled)));
+
+        String biomeKey = Biomes.OVERWORLD_GRASSLANDS.translationKey;
+        boolean biomeEnabled = GameSettings.BIOME_IN_OVERLAY.value;
+        lines.add(new RenderLine(I18n.getInstance().translateKey(biomeKey), getPreviewColor(0xFFFFFFFF, biomeEnabled)));
+
+        drawLines(lines, x, y);
+    }
+
+    private void drawLines(List<RenderLine> lines, int x, int y) {
+        if (lines.isEmpty()) return;
+
+        int lineHeight = 10;
+        int totalHeight = lines.size() * lineHeight;
+
+        float yMult = GameSettings.VERTICAL_INFO_TEXT_ALIGNMENT.value.multiplier;
+
+        int padding = 2;
+        int startY = y + padding + (int) ((this.getDisplayedYSize() - (padding * 2) - totalHeight) * yMult);
+
+        for (int i = 0; i < lines.size(); i++) {
+            RenderLine line = lines.get(i);
+            int currentY = startY + (i * lineHeight);
+            drawAlignedString(line.text, x, currentY, this.getDisplayedXSize(), line.color);
         }
     }
-}
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
index 473b48cf0..e572bb875 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
@@ -10,21 +10,58 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.material.Materials;
 
-
-public class HudComponentOxygenBar
-    extends HudComponentMovable {
+public class HudComponentOxygenBar extends HudComponentMovable {
     private final IconCoordinate air;
     private final IconCoordinate air_pop;
 
     public HudComponentOxygenBar(String key, Layout layout) {
-        super(key, 81, 10, layout);
+        super(key, 81, 9, layout);
         this.air = TextureRegistry.getTexture("minecraft:gui/hud/air");
         this.air_pop = TextureRegistry.getTexture("minecraft:gui/hud/air_pop");
     }
 
+    private boolean isVertical() {
+        return GameSettings.VERTICAL_OXYGEN_BAR.value;
+    }
+
+    private boolean isFlipped() {
+        return GameSettings.FLIP_OXYGEN_BAR.value;
+    }
+
+    @Override
+    public int getDisplayedXSize() {
+        return this.isVertical() ? super.getDisplayedYSize() : super.getDisplayedXSize();
+    }
+
+    @Override
+    public int getDisplayedYSize() {
+        return this.isVertical() ? super.getDisplayedXSize() : super.getDisplayedYSize();
+    }
+
+    @Override
+    public int getTrueXSize() {
+        return this.isVertical() ? super.getTrueYSize() : super.getTrueXSize();
+    }
+
+    @Override
+    public int getTrueYSize() {
+        return this.isVertical() ? super.getTrueXSize() : super.getTrueYSize();
+    }
+
     @Override
     public boolean isVisible() {
-        return GameSettings.IMMERSIVE_MODE.drawHotbar() && !mc.thePlayer.getGamemode().hasInvulnerablePlayer() && mc.thePlayer.isUnderLiquid(Materials.WATER);
+        if (mc.thePlayer == null) {
+            return GameSettings.IMMERSIVE_MODE.drawHotbar();
+        }
+        return GameSettings.IMMERSIVE_MODE.drawHotbar() &&
+                !mc.thePlayer.getGamemode().hasInvulnerablePlayer() &&
+                mc.thePlayer.isUnderLiquid(Materials.WATER) &&
+                !GameSettings.HIDE_OXYGEN_BAR.value;
+    }
+
+    @Override
+    public boolean isPreviewTranslucent() {
+        return GameSettings.HIDE_OXYGEN_BAR.value;
     }
 
     @Override
@@ -36,13 +73,28 @@ public class HudComponentOxygenBar
         GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
         GLRenderer.enableState(State.BLEND);
 
+        boolean isVertical = this.isVertical();
+        boolean isFlipped = this.isFlipped();
+
         int numBubbles = (int) Math.ceil(((double) (mc.thePlayer.airSupply - 2) * 10D) / 300D);
         int numPops = (int) Math.ceil(((double) mc.thePlayer.airSupply * 10D) / 300D) - numBubbles;
+
         for (int i = 0; i < numBubbles + numPops; i++) {
+            int xIcon;
+            int yIcon;
+
+            if (isVertical) {
+                xIcon = x;
+                yIcon = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+            } else {
+                xIcon = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                yIcon = y;
+            }
+
             if (i < numBubbles) {
-                hud.drawGuiIcon(x + i * 8, y, 9, 9, this.air);
+                hud.drawGuiIcon(xIcon, yIcon, 9, 9, this.air);
             } else {
-                hud.drawGuiIcon(x + i * 8, y, 9, 9, this.air_pop);
+                hud.drawGuiIcon(xIcon, yIcon, 9, 9, this.air_pop);
             }
         }
     }
@@ -54,16 +106,32 @@ public class HudComponentOxygenBar
 
         // Setup rendering
         GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+        renderTranslucency();
         GLRenderer.enableState(State.BLEND);
 
+        boolean isVertical = this.isVertical();
+        boolean isFlipped = this.isFlipped();
+
         int numBubbles = 5;
         int numPops = 6 - numBubbles;
+
         for (int i = 0; i < numBubbles + numPops; i++) {
+            int xIcon;
+            int yIcon;
+
+            if (isVertical) {
+                xIcon = x;
+                yIcon = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+            } else {
+                xIcon = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                yIcon = y;
+            }
+
             if (i < numBubbles) {
-                gui.drawGuiIcon(x + i * 8, y, 9, 9, this.air);
+                gui.drawGuiIcon(xIcon, yIcon, 9, 9, this.air);
             } else {
-                gui.drawGuiIcon(x + i * 8, y, 9, 9, this.air_pop);
+                gui.drawGuiIcon(xIcon, yIcon, 9, 9, this.air_pop);
             }
         }
     }
-}
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java
index 5a3c03019..8e8e5f8b9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java
@@ -18,6 +18,9 @@ public class HudComponentRotationLock
 
     @Override
     public boolean isVisible() {
+        if (mc.thePlayer == null) {
+            return GameSettings.IMMERSIVE_MODE.drawOverlays();
+        }
         return mc.thePlayer.rotationLock != null && mc.thePlayer.rotationLock != Direction.NONE && GameSettings.IMMERSIVE_MODE.drawOverlays();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java
index db97755eb..37d25ac4d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java
@@ -46,8 +46,8 @@ public class HudComponentSubtitles extends HudComponentMovable {
     {
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
-        int width = getXSize();
-        int height = getYSize();
+        int width = getDisplayedXSize();
+        int height = getDisplayedYSize();
         int xRight = x + width;
         int yBottom = y + height;
         int messagesToShow = height/10;
